<?php
/**
 * Class InvoicepdfOrder_Overview extends order_overview.
 */
class bn_exportOrder_Overview extends bn_exportOrder_Overview_parent
{
	
    /**
     * Cached active shop object
     *
     * @var object
     */
    protected $_oActShop = null;	
	
	protected $_sThisTemplate = 'order_overview.tpl';
	
	protected $_sSendungsreferenz = null;
	protected $_sAbsenderreferenz = null;
	protected $_sProdukt = null;
	protected $_sAbrechnungsnummer = null;
	
    public function __construct()
    {
        $config     = oxRegistry::get('oxConfig');
       
        $this->_sProdukt = $config->getConfigParam('sProdukt');
        $this->_sAbrechnungsnummer = $config->getConfigParam('sAbrechnungsnummer');
                
        parent::__construct();

    }	

    /**
     * Add Languages to parameters.
     *
     * @return string
     */
    public function render()
    {
        $return = parent::render();

        $oLang = oxRegistry::getLang();
        $this->_aViewData["alangs"] = $oLang->getLanguageNames();
		
		// Bis hierher Modul OK!
		// Echo erscheint auf Übersicht Seite der bestellungen

        return $return;
    }
	
	protected function utf8_converter($array)
	{
		array_walk($array, function(&$item, $key){
			 $item = utf8_decode($item);
		});
	 
		return $array;
	}	
	
    /**
     * Template variable getter. Returns country ISO 3
     *
     * @return string
     */
    public function getCountryISO3($countryid)
    {
        $oCountry = oxNew('oxCountry');
        $oCountry->load($countryid);
        return $oCountry->oxcountry__oxisoalpha3->value;
    }		
	
    /**
     * Returns active shop object.
     *
     * @return oxshop $oUser
     */
    protected function _getActShop()
    {
        // shop is allready loaded
        if ($this->_oActShop !== null) {
            return $this->_oActShop;
        }

        $this->_oActShop = oxNew('oxshop');
        $this->_oActShop->load($this->getConfig()->getShopId());

        return $this->_oActShop;
    }	

    /**
     * Performs PDF export to user (outputs file to save).
     */
    public function bn_exportCSV()
    {
        $soxId = $this->getEditObjectId();
		$config     = oxRegistry::get('oxConfig');
		$oShop = $this->_getActShop();
	
		
        if ($soxId != "-1" && isset($soxId)) {
			// $aPaymentList = oxRegistry::get("oxPaymentList")->getPaymentList($sDelSetId, $dBasketPrice, $oUser);
            // load object
            $oOrder = oxNew("oxorder");
            if ($oOrder->load($soxId)) {
                $oUtils = oxRegistry::getUtils();
				
				// loading user
				$oUser = oxNew('oxuser');
				$oUser->load($oOrder->oxorder__oxuserid->value);					
                
                $sFilename = $oOrder->oxorder__oxordernr->value . ".csv";
				$OXORDERNR = $oOrder->oxorder__oxordernr->value;
				$sCSV = utf8_decode("Sendungsreferenz;Sendungsdatum;Absender Name 1;Absender Name 2;Absender Name 3;Absender Straße;Absender Hausnummer;Absender PLZ;Absender Ort;Absender Provinz;Absender Land;Absenderreferenz;Absender E-Mail-Adresse;Absender Telefonnummer;Empfänger Name 1;Empfänger Name 2 / Postnummer;Empfänger Name 3;Empfänger Straße;Empfänger Hausnummer;Empfänger PLZ;Empfänger Ort;Empfänger Provinz;Empfänger Land;Empfängerreferenz;Empfänger E-Mail-Adresse;Empfänger Telefonnummer;Gewicht;Länge;Breite;Höhe;Produkt- und Servicedetails;Retourenempfänger Name 1;Retourenempfänger Name 2;Retourenempfänger Name 3;Retourenempfänger Straße;Retourenempfänger Hausnummer;Retourenempfänger PLZ;Retourenempfänger Ort;Retourenempfänger Provinz;Retourenempfänger Land;Retourenrempfänger E-Mail-Adresse;Retourenempfänger Telefonnummer;Retouren-Abrechnungsnummer;Abrechnungsnummer;Service - Versandbestätigung - E-Mail Text-Vorlage;Service - Versandbestätigung - E-Mail-Adresse;Service - Nachnahme - Kontoreferenz;Service - Nachnahme - Betrag;Service - Nachnahme - IBAN;Service - Nachnahme - BIC;Service - Nachnahme - Zahlungsempfänger;Service - Nachnahme - Bankname;Service - Nachnahme - Verwendungszweck 1;Service - Nachnahme - Verwendungszweck 2;Service - Transportversicherung - Betrag;Service - Weltpaket - Vorausverfügungstyp;Service - DHL Europaket - Frankaturtyp;Sendungsdokumente - Ausfuhranmeldung;Sendungsdokumente - Rechnungsnummer;Sendungsdokumente - Genehmigungsnummer;Sendungsdokumente - Bescheinigungsnummer;Sendungsdokumente - Sendungsart;Sendungsdokumente - Beschreibung;Sendungsdokumente - Entgelte;Sendungsdokumente - Gesamtnettogewicht;Sendungsdokumente - Beschreibung (WP1);Sendungsdokumente - Menge (WP1);Sendungsdokumente - Zollwert (WP1);Sendungsdokumente - Ursprungsland (WP1);Sendungsdokumente - Zolltarifnummer (WP1);Sendungsdokumente - Gewicht (WP1);Sendungsdokumente - Beschreibung (WP2);Sendungsdokumente - Menge (WP2);Sendungsdokumente - Zollwert (WP2);Sendungsdokumente - Ursprungsland (WP2);Sendungsdokumente - Zolltarifnummer (WP2);Sendungsdokumente - Gewicht (WP2);Sendungsdokumente - Beschreibung (WP3);Sendungsdokumente - Menge (WP3);Sendungsdokumente - Zollwert (WP3);Sendungsdokumente - Ursprungsland (WP3);Sendungsdokumente - Zolltarifnummer (WP3);Sendungsdokumente - Gewicht (WP3);Sendungsdokumente - Beschreibung (WP4);Sendungsdokumente - Menge (WP4);Sendungsdokumente - Zollwert (WP4);Sendungsdokumente - Ursprungsland (WP4);Sendungsdokumente - Zolltarifnummer (WP4);Sendungsdokumente - Gewicht (WP4);Sendungsdokumente - Beschreibung (WP5);Sendungsdokumente - Menge (WP5);Sendungsdokumente - Zollwert (WP5);Sendungsdokumente - Ursprungsland (WP5);Sendungsdokumente - Zolltarifnummer (WP5);Sendungsdokumente - Gewicht (WP5);Sendungsdokumente - Beschreibung (WP6);Sendungsdokumente - Menge (WP6);Sendungsdokumente - Zollwert (WP6);Sendungsdokumente - Ursprungsland (WP6);Sendungsdokumente - Zolltarifnummer (WP6);Sendungsdokumente - Gewicht (WP6)")."\n";
				// https://www.dhl-geschaeftskundenportal.de/dhl-vls/gw/onlinehelp/vls/de/ShipmentImportDetailsPageDHLExample
				
				// Sendungsreferenz;Sendungsdatum;
				$saField['Sendungsreferenz']= strip_tags($oShop->oxshops__oxcompany->getRawValue())." BestNr ".$OXORDERNR;
				$saField['Sendungsdatum']= date("d.m.y");
				// Absender Name 1;Absender Name 2;Absender Name 3;Absender Straße;Absender Hausnummer;Absender PLZ;Absender Ort;Absender Provinz;Absender Land;Absenderreferenz;Absender E-Mail-Adresse;Absender Telefonnummer;
				$saField['AName1']= strip_tags($oShop->oxshops__oxcompany->getRawValue());
				$saField['AName2']= "";
				$saField['AName3']= "";
				// HausNr suchen
				$street = strip_tags($oShop->oxshops__oxstreet->getRawValue());
				$nr = substr (strrchr ($street, " "), 1); 
				$streetname = substr ($street,0,(strlen($street)-strlen($nr))); 
				$saField['AStrasse']= $streetname;
				$saField['AHausnr']= $nr;
				$saField['APLZ']= strip_tags($oShop->oxshops__oxzip->value);
				$saField['AOrt']= strip_tags($oShop->oxshops__oxcity->getRawValue());
				$saField['AProvinz']= "";
				$saField['ALand']=  "DEU"; //  strip_tags($oShop->oxshops__oxcountry->getRawValue());
				$saField['Absenderreferenz']= "Shop Bestellung ".$OXORDERNR;
				$saField['AEmail']= strip_tags($oShop->oxshops__oxorderemail->value);
				$saField['ATel']= strip_tags($oShop->oxshops__oxtelefon->value);
				// Empfänger Name 1;Empfänger Name 2 / Postnummer;Empfänger Name 3;Empfänger Straße;Empfänger Hausnummer;Empfänger PLZ;Empfänger Ort;Empfänger Provinz;Empfänger Land;Empfängerreferenz;Empfänger E-Mail-Adresse;Empfänger Telefonnummer;
				
				if ($oOrder->oxorder__oxdelstreet->value>"") {
					$name1 = $oOrder->oxorder__oxdelcompany->value;
					$name2 = $oOrder->oxorder__oxdelfname->value." ".$oOrder->oxorder__oxdellname->value;
					if ($name1>"") {
						$saField['EName1']= $name1;
						$saField['EName2']= $name2;
					} else {
						$saField['EName1']= $name2;
						$saField['EName2']= "";
					}
					$saField['EName3']= "";
					$saField['EStrasse']= $oOrder->oxorder__oxdelstreet->value;
					$saField['EHausnr']=  $oOrder->oxorder__oxdelstreetnr->value;
					$saField['EPLZ']=  $oOrder->oxorder__oxdelzip->value;
					$saField['EOrt']=  $oOrder->oxorder__oxdelcity->value;
					$saField['EProvinz']= "";
					// Achtung immer interne Funktionen mit $this-> aufrufen!
					$saField['ELand']=  $this->getCountryISO3($oOrder->oxorder__oxdelcountryid->value);// DEU ISO3 	
				} else {
					$name1 = $oOrder->oxorder__oxbillcompany->value;
					$name2 = $oOrder->oxorder__oxbillfname->value." ".$oOrder->oxorder__oxbilllname->value;
					if ($name1>"") {
						$saField['EName1']= $name1;
						$saField['EName2']= $name2;
					} else {
						$saField['EName1']= $name2;
						$saField['EName2']= "";
					}				
					$saField['EName3']= "";
					$saField['EStrasse']= $oOrder->oxorder__oxbillstreet->value;
					$saField['EHausnr']=  $oOrder->oxorder__oxbillstreetnr->value;
					$saField['EPLZ']=  $oOrder->oxorder__oxbillzip->value;
					$saField['EOrt']=  $oOrder->oxorder__oxbillcity->value;
					$saField['EProvinz']= "";
					$saField['ELand']=  $this->getCountryISO3($oOrder->oxorder__oxbillcountryid->value);  //  DEU ISO3 		
				}
				$saField['Empfängerreferenz']= "KdNr ".$oUser->oxuser__oxcustnr->value;  // Kudnennr 
				$saField['EEmail']=  $oOrder->oxorder__oxbillemail->value; 
				$saField['ETel']=   $oOrder->oxorder__oxbillfon->value; 
				// Gewicht;Länge;Breite;Höhe;Produkt- und Servicedetails;
				$saField['Gewicht']= "10";
				$saField['Länge']= "";
				$saField['Breite']= "";
				$saField['Höhe']= "";
				/*
				Die Maximalausprägung für Paket National (V01PAK) ist
				V01PAK.V01TV.V01VV.V01BLNN.V01EH.V07RET.V01GOGR.V00VSB.V00SPERR

				Die Maximalausprägung für WELTPAKET ist
				V53WPAK.V53GOGR.V53TV.V53RS.V53VV.V53COD.V00SPERR.V00VSB

				Die Maximalausprägung für DHL Europaket ist
				V54EPAK.V54TV.V54VV.V00SPERR.V00VSB
				*/			
				$this->_sProdukt = $config->getConfigParam('sProdukt');
				if ($this->_sProdukt>"") $saField['Produkt']= $this->_sProdukt;
				else $saField['Produkt']= "V01PAK";
				// Retourenempfänger Name 1;Retourenempfänger Name 2;Retourenempfänger Name 3;Retourenempfänger Straße;Retourenempfänger Hausnummer;Retourenempfänger PLZ;Retourenempfänger Ort;Retourenempfänger Provinz;Retourenempfänger Land;Retourenrempfänger E-Mail-Adresse;Retourenempfänger Telefonnummer;Retouren-Abrechnungsnummer;
				$saField['Retour1']= "";
				$saField['Retour2']= "";
				$saField['Retour3']= "";
				$saField['Retour4']= "";
				$saField['Retour5']= "";
				$saField['Retour6']= "";
				$saField['Retour7']= "";
				$saField['Retour8']= "";
				$saField['Retour9']= "";			
				$saField['Retour10']= "";
				$saField['Retour11']= "";
				$saField['Retour12']= "";
				// Abrechnungsnummer;Service - Versandbestätigung - E-Mail Text-Vorlage;Service - Versandbestätigung - E-Mail-Adresse;Service - Nachnahme - Kontoreferenz;Service - Nachnahme - Betrag;Service - Nachnahme - IBAN;Service - Nachnahme - BIC;Service - Nachnahme - Zahlungsempfänger;Service - Nachnahme - Bankname;Service - Nachnahme - Verwendungszweck 1;Service - Nachnahme - Verwendungszweck 2;Service - Transportversicherung - Betrag;Service - Weltpaket - Vorausverfügungstyp;Service - DHL Europaket - Frankaturtyp;Sendungsdokumente - Ausfuhranmeldung;Sendungsdokumente - Rechnungsnummer;Sendungsdokumente - Genehmigungsnummer;Sendungsdokumente - Bescheinigungsnummer;Sendungsdokumente - Sendungsart;Sendungsdokumente - Beschreibung;Sendungsdokumente - Entgelte;Sendungsdokumente - Gesamtnettogewicht;Sendungsdokumente - Beschreibung (WP1);Sendungsdokumente - Menge (WP1);Sendungsdokumente - Zollwert (WP1);Sendungsdokumente - Ursprungsland (WP1);Sendungsdokumente - Zolltarifnummer (WP1);Sendungsdokumente - Gewicht (WP1);Sendungsdokumente - Beschreibung (WP2);Sendungsdokumente - Menge (WP2);Sendungsdokumente - Zollwert (WP2);Sendungsdokumente - Ursprungsland (WP2);Sendungsdokumente - Zolltarifnummer (WP2);Sendungsdokumente - Gewicht (WP2);Sendungsdokumente - Beschreibung (WP3);Sendungsdokumente - Menge (WP3);Sendungsdokumente - Zollwert (WP3);Sendungsdokumente - Ursprungsland (WP3);Sendungsdokumente - Zolltarifnummer (WP3);Sendungsdokumente - Gewicht (WP3);Sendungsdokumente - Beschreibung (WP4);Sendungsdokumente - Menge (WP4);Sendungsdokumente - Zollwert (WP4);Sendungsdokumente - Ursprungsland (WP4);Sendungsdokumente - Zolltarifnummer (WP4);Sendungsdokumente - Gewicht (WP4);Sendungsdokumente - Beschreibung (WP5);Sendungsdokumente - Menge (WP5);Sendungsdokumente - Zollwert (WP5);Sendungsdokumente - Ursprungsland (WP5);Sendungsdokumente - Zolltarifnummer (WP5);Sendungsdokumente - Gewicht (WP5);Sendungsdokumente - Beschreibung (WP6);Sendungsdokumente - Menge (WP6);Sendungsdokumente - Zollwert (WP6);Sendungsdokumente - Ursprungsland (WP6);Sendungsdokumente - Zolltarifnummer (WP6);Sendungsdokumente - Gewicht (WP6)
				if ($this->_sAbrechnungsnummer>"") $saField['Abrechnungsnummer']= $this->_sAbrechnungsnummer;
				else $saField['Abrechnungsnummer']= "";
				$saField['Service']= "DHL Standard Versandbestätigung";
				$saField = $this->utf8_converter($saField);		

				$sCSV .= implode(";",$saField);
				
                $oUtils->setHeader("Pragma: public");
                $oUtils->setHeader("Cache-Control: must-revalidate, post-check=0, pre-check=0");
                $oUtils->setHeader("Expires: 0");
                $oUtils->setHeader("Content-type: application/octet-stream");
                $oUtils->setHeader("Content-Disposition: attachment; filename=" . $sFilename);
                oxRegistry::getUtils()->showMessageAndExit($sCSV);
            }
        }
    }
}
